; Copyright (C) 2007 Jean-Michel Richer

global	func_byte_vect1_16x
global  func_byte_vect2_16x
global  func_byte_vect3_16x
global	func_byte_vect4
global	func_byte_vect5

extern printf

section .data

msg: db '%x %d <- %d %d, fitch=%d',10,0

align 16
un: dd 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF

align 16

translation_table:
db 0, 1, 1, 2, 1, 2, 2, 3
db 1, 2, 2, 3, 2, 3, 3, 4
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 4, 5, 5, 6, 5, 6, 6, 7
db 5, 6, 6, 7, 6, 7, 7, 8

section .text


display:
	push	ebp
	mov	ebp,esp
	pusha
	
	xor	ecx,ecx

display_loop:
	pusha
	push	eax ; save fitch for display
	xor	eax,eax
	mov	al,[edi+ecx] ; B[i]
	push	eax
	mov	al,[esi+ecx] ; A[i]
	push	eax
	mov	al,[ebx+ecx] ; C[i]
	push	eax
	mov	eax,ebx
	add	eax,ecx
	push	eax
	push 	dword msg
	call 	printf
	add	esp,24
	popa 
	inc	ecx
	cmp	ecx,16
	jl	display_loop
	popa
	mov	esp,ebp
	pop	ebp
	ret

;
; only valid for 16x data
;

func_byte_vect1_16x:
	push 	ebp	
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx
	push	ecx
	push	edx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB
	mov	ebx,[ebp+16] ; vC

	xor	eax,eax
	xor	ecx,ecx

	movdqu	xmm6,[un]

vect1_loop:
	movdqa	xmm0,[esi+ecx] ; xmm0 <- p

	movdqa	xmm2,[edi+ecx] ; xmm2 <- q
	movdqa	xmm1,xmm0      ; xmm1 <- p
	pxor	xmm3,xmm3
	pxor	xmm5,xmm5
	pand	xmm0,xmm2      ; xmm0 <- p & q
	por	xmm1,xmm2      ; xmm1 <- p | q
	movdqa	xmm4,xmm0      ; xmm4 <- p & q
	pcmpeqb xmm4,xmm3      ; xmm4[i]
	pmovmskb edx,xmm4

	movdqa	xmm5,xmm6
	pxor	xmm5,xmm4      ; xmm5 = ~xmm4

	pand	xmm1,xmm4
	pand	xmm0,xmm5
	por	xmm0,xmm1

	movdqa	[ebx+ecx],xmm0

	bt      edx,0
	adc	eax,0
	bt      edx,1
	adc	eax,0
	bt      edx,2
	adc	eax,0
	bt      edx,3
	adc	eax,0
	bt      edx,4
	adc	eax,0
	bt      edx,5
	adc	eax,0
	bt      edx,6
	adc	eax,0
	bt      edx,7

	adc	eax,0
	bt      edx,8
	adc	eax,0
	bt      edx,9
	adc	eax,0
	bt      edx,10
	adc	eax,0
	bt      edx,11
	adc	eax,0
	bt      edx,12
	adc	eax,0
	bt      edx,13
	adc	eax,0
	bt      edx,14
	adc	eax,0
	bt      edx,15
	adc	eax,0
	; eax contains fitch score

	add	ecx,16
	cmp	ecx,[ebp+20]
	jl 	vect1_loop

	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi

	mov	esp,ebp
	pop	ebp
	ret

;
; only valid for 16x data
;

func_byte_vect2_16x:
	push 	ebp	
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx
	push	ecx
	push	edx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; vB
	mov	ebx,[ebp+16] ; vC

	xor	eax,eax
	xor	ecx,ecx

	movdqu	xmm6,[un]

vect2_loop:
	movdqa	xmm0,[esi+ecx] ; xmm0 <- p

	movdqa	xmm2,[edi+ecx] ; xmm2 <- q
	movdqa	xmm1,xmm0      ; xmm1 <- p
	pxor	xmm3,xmm3
	pxor	xmm5,xmm5
	pand	xmm0,xmm2      ; xmm0 <- p & q
	por	xmm1,xmm2      ; xmm1 <- p | q
	movdqa	xmm4,xmm0      ; xmm4 <- p & q
	pcmpeqb xmm4,xmm3      ; xmm4[i]
	pmovmskb edx,xmm4

	movdqa	xmm5,xmm6
	pxor	xmm5,xmm4      ; xmm5 = ~xmm4

	pand	xmm1,xmm4
	pand	xmm0,xmm5
	por	xmm0,xmm1

	movdqa	[ebx+ecx],xmm0

	push	ebx

	mov	ebx,edx
	xor	edx,edx
	mov	dl,bl
	mov	dl,[translation_table+edx]
	add	eax,edx
	mov	dl,bh
	mov	dl,[translation_table+edx]
	add	eax,edx

	pop	ebx

	; eax contains fitch score

	add	ecx,16
	cmp	ecx,[ebp+20]
	jl 	vect2_loop

	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi

	mov	esp,ebp
	pop	ebp
	ret

;
; only valid for 16x data 
;

func_byte_vect3_16x:
	push 	ebp	
	mov	ebp,esp

	sub	esp,4

	push	esi
	push	edi
	push	ebx
	push	ecx
	push	edx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB
	mov	ebx,[ebp+16] ; vC

	xor	eax,eax
	mov	[ebp-4],eax
	xor	ecx,ecx

	movdqu	xmm6,[un]

vect3_loop:
	movdqa	xmm0,[esi+ecx] ; xmm0 <- p

	movdqa	xmm2,[edi+ecx] ; xmm2 <- q
	movdqa	xmm1,xmm0      ; xmm1 <- p
	pxor	xmm3,xmm3
	pxor	xmm5,xmm5
	pand	xmm0,xmm2      ; xmm0 <- p & q
	por	xmm1,xmm2      ; xmm1 <- p | q
	movdqa	xmm4,xmm0      ; xmm4 <- p & q
	pcmpeqb xmm4,xmm3      ; xmm4[i]
	pmovmskb edx,xmm4

	movdqa	xmm5,xmm6
	pxor	xmm5,xmm4      ; xmm5 = ~xmm4

	pand	xmm1,xmm4
	pand	xmm0,xmm5
	por	xmm0,xmm1

	movdqa	[ebx+ecx],xmm0

	push	ebx

	mov	ebx,edx
	xor	edx,edx
	mov	dl,bl
	mov	dl,[translation_table+edx]
	add	[ebp-4],edx
	mov	dl,bh
	mov	dl,[translation_table+edx]
	add	[ebp-4],edx

	pop	ebx

	; eax contains fitch score

	add	ecx,16
	cmp	ecx,[ebp+20]
	jl 	vect3_loop

	mov	eax,[ebp-4]

	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi

	mov	esp,ebp
	pop	ebp
	ret



; ============================================================
; valid for all data size dealing with bytes
; ============================================================
; BEST under Core 2 Duo
; ============================================================

func_byte_vect4:
	push 	ebp	
	mov	ebp,esp

	sub	esp,4

	push	esi
	push	edi
	push	ebx
	push	ecx
	push	edx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB
	mov	ebx,[ebp+16] ; vC

	xor	eax,eax
	mov	[ebp-4],eax
	mov	ecx,[ebp+20]
	shr	ecx,4
	jcxz	vect4_loop2

	pxor	xmm3,xmm3	
	movdqu	xmm6,[un]

vect4_loop1:
	movdqa	xmm0,[esi] ; xmm0 <- p
	
	movdqa	xmm2,[edi] ; xmm2 <- q

	movdqa	xmm1,xmm0      ; xmm1 <- p
	
	pxor	xmm5,xmm5
	pand	xmm0,xmm2      ; xmm0 <- p & q
	por	xmm1,xmm2      ; xmm1 <- p | q
	movdqa	xmm4,xmm0      ; xmm4 <- p & q
	pcmpeqb xmm4,xmm3      ; xmm4[i]
	pmovmskb edx,xmm4

	movdqa	xmm5,xmm6
	pxor	xmm5,xmm4      ; xmm5 = ~xmm4

	pand	xmm1,xmm4
	add	esi,16
	pand	xmm0,xmm5
	add	edi,16
	por	xmm0,xmm1

	movdqa	[ebx],xmm0
	push	ebx

	mov	ebx,edx
	xor	edx,edx
	mov	dl,bl
	mov	dl,[translation_table+edx]
	add	eax,edx
	mov	dl,bh
	mov	dl,[translation_table+edx]
	add	eax,edx

	pop	ebx

	; eax contains fitch score

	add	ebx,16
	dec	ecx
	jnz 	vect4_loop1

vect4_loop2:
	mov	[ebp-4],eax

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB

	; round ecx to multiple of 16
	mov	ecx,[ebp+20]
	shr	ecx,4   ; ecx / 16
	shl 	ecx,4	; ecx * 16

vect4_loop2_cond:
	cmp	ecx,[ebp+20]
	jz	vect4_loop2_end
	mov	al,[esi+ecx]
	mov	bl,[edi+ecx]
	mov	dl,bl
	or 	bl,al
	and	dl,al
	xor	eax,eax
	test	dl,dl
	cmovz	edx,ebx
	setz	al
	mov	ebx,[ebp+16]
	mov	[ebx+ecx],dl
	add	[ebp-4],eax
	inc	ecx	

	jmp 	vect4_loop2_cond

vect4_loop2_end:

	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi

	mov	eax,[ebp-4]
	mov	esp,ebp
	pop	ebp
	ret


; ============================================================
; valid for all data size dealing with bytes
; ============================================================

func_byte_vect5:
	push 	ebp	
	mov	ebp,esp

	sub	esp,4

	push	esi
	push	edi
	push	ebx
	push	ecx
	push	edx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB
	mov	ebx,[ebp+16] ; vC

	xor	eax,eax
	mov	[ebp-4],eax
	mov	ecx,[ebp+20]
	shr	ecx,4
;	jz	vect5_loop2

	pxor	xmm3,xmm3	
	movdqu	xmm6,[un]

vect5_loop1:
	movdqa	xmm0,[esi] ; xmm0 <- p
	
	movdqa	xmm2,[edi] ; xmm2 <- q

	movdqa	xmm1,xmm0      ; xmm1 <- p
	
	pxor	xmm5,xmm5
	pand	xmm0,xmm2      ; xmm0 <- p & q
	por	xmm1,xmm2      ; xmm1 <- p | q
	movdqa	xmm4,xmm0      ; xmm4 <- p & q
	pcmpeqb xmm4,xmm3      ; xmm4[i]
	pmovmskb edx,xmm4

	movdqa	xmm5,xmm6
	pxor	xmm5,xmm4      ; xmm5 = ~xmm4

	pand	xmm1,xmm4
	add	esi,16
	pand	xmm0,xmm5
	add	edi,16
	por	xmm0,xmm1

	movdqa	[ebx],xmm0

	push	eax
	
; count number of bits from AMD Integer optimization
; popcount function
	mov	eax,edx
	shr	eax,1
	and	eax,0x55555555
	sub	edx,eax
	mov	eax,edx
	shr	edx,2
	and	eax,0x33333333
	and	edx,0x33333333
	add	eax,edx
	mov	edx,eax
	shr	eax,4
	add	eax,edx
	and	eax,0x0F0F0F0F
	imul	eax,0x01010101
	shr	eax,24
	mov	edx,eax

	pop	eax
	add	eax,edx
	add	ebx,16

	; eax contains fitch score

	dec	ecx
	jnz 	vect5_loop1

vect5_loop2:
	mov	[ebp-4],eax

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB

	; round ecx to multiple of 16
	mov	ecx,[ebp+20]
	shr	ecx,4   ; ecx / 16
	shl 	ecx,4	; ecx * 16

vect5_loop2_cond:
	cmp	ecx,[ebp+20]
	jz	vect5_loop2_end
	mov	al,[esi+ecx]
	mov	bl,[edi+ecx]
	mov	dl,bl
	or 	bl,al
	and	dl,al
	xor	eax,eax
	test	dl,dl
	cmovz	edx,ebx
	setz	al
	mov	ebx,[ebp+16]
	mov	[ebx+ecx],dl
	add	[ebp-4],eax
	inc	ecx	

	jmp 	vect5_loop2_cond

vect5_loop2_end:

	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi

	mov	eax,[ebp-4]
	mov	esp,ebp
	pop	ebp
	ret








