; Copyright (C) 2007 Jean-Michel Richer

global	func_int_vect1_16x
global  func_int_vect2_16x
global  func_int_vect3_16x
global	func_int_vect4

extern printf

section .data

msg: db '%x %d <- %d %d, fitch=%d',10,0

align 16
un: dd 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF, 0xFFFFFFFF

align 16

translation_table:
db 0, 1, 1, 2, 1, 2, 2, 3
db 1, 2, 2, 3, 2, 3, 3, 4
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 1, 2, 2, 3, 2, 3, 3, 4
db 2, 3, 3, 4, 3, 4, 4, 5
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 2, 3, 3, 4, 3, 4, 4, 5
db 3, 4, 4, 5, 4, 5, 5, 6
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 3, 4, 4, 5, 4, 5, 5, 6
db 4, 5, 5, 6, 5, 6, 6, 7
db 4, 5, 5, 6, 5, 6, 6, 7
db 5, 6, 6, 7, 6, 7, 7, 8

section .text


display:
	push	ebp
	mov	ebp,esp
	pusha
	
	xor	ecx,ecx

display_loop:
	pusha
	push	eax ; save fitch for display
	xor	eax,eax
	mov	al,[edi+ecx] ; B[i]
	push	eax
	mov	al,[esi+ecx] ; A[i]
	push	eax
	mov	al,[ebx+ecx] ; C[i]
	push	eax
	mov	eax,ebx
	add	eax,ecx
	push	eax
	push 	dword msg
	call 	printf
	add	esp,24
	popa 
	inc	ecx
	cmp	ecx,16
	jl	display_loop

	popa
	mov	esp,ebp
	pop	ebp
	ret

;
; only valid for 16x data
;

func_int_vect1_16x:
	push 	ebp	
	mov	ebp,esp
	push	esi
	push	edi
	push	ebx
	push	ecx
	push	edx

	mov	esi,[ebp+8]  ; vA
	mov	edi,[ebp+12] ; VB
	mov	ebx,[ebp+16] ; vC

	xor	eax,eax
	xor	ecx,ecx

	movdqu	xmm6,[un]

vect1_loop:
	movdqa	xmm0,[esi+ecx] ; xmm0 <- p

	movdqa	xmm2,[edi+ecx] ; xmm2 <- q
	movdqa	xmm1,xmm0      ; xmm1 <- p
	pxor	xmm3,xmm3
	pxor	xmm5,xmm5
	pand	xmm0,xmm2      ; xmm0 <- p & q
	por	xmm1,xmm2      ; xmm1 <- p | q
	movdqa	xmm4,xmm0      ; xmm4 <- p & q
	pcmpeqd xmm4,xmm3      ; xmm4[i]
	pmovmskb edx,xmm4

	movdqa	xmm5,xmm6
	pxor	xmm5,xmm4      ; xmm5 = ~xmm4

	pand	xmm1,xmm4
	pand	xmm0,xmm5
	por	xmm0,xmm1

	movdqa	[ebx+ecx],xmm0

	bt      edx,0
	adc	eax,0
	bt      edx,4
	adc	eax,0
	bt      edx,8
	adc	eax,0
	bt      edx,12
	adc	eax,0

	; eax contains fitch score

	add	ecx,16
	mov	edx,[ebp+20]
	shl	edx,2
	cmp	ecx,edx
	jl 	vect1_loop

	pop	edx
	pop	ecx
	pop	ebx
	pop	edi
	pop	esi

	mov	esp,ebp
	pop	ebp
	ret

;
; only valid for 16x data
;



