/* Copyright (C) 2007 Jean-Michel Richer */
#include "test_int_func.h"
#include <stdio.h>
#include <stdlib.h>

/**
 * basic function : compute fitch score
 */
int func_int_basic(int *vA, int *vB, int *vC, int len) {
  int i, f=0;

  for (i = 0; i < len; i++) {
    vC[i] = vA[i] & vB[i];
    if (vC[i] == 0) {
      vC[i] = vA[i] | vB[i];
      ++f;
    }
  }
  return f;
}

/**
 * unroll4
 *
 */
int func_int_unroll4(int *vA, int *vB, int *vC, int len) {
  int i, f=0;
  int len4 = (len & ~3);

  for (i = 0; i < len4; i+=4) {
    vC[i]   = vA[i] & vB[i];
    if (vC[i] == 0) {
      vC[i] = vA[i] | vB[i];
      ++f;
    }
    vC[i+1] = vA[i+1] & vB[i+1];
    if (vC[i+1] == 0) {
      vC[i+1] = vA[i+1] | vB[i+1];
      ++f;
    }
    vC[i+2] = vA[i+2] & vB[i+2];
    if (vC[i+2] == 0) {
      vC[i+2] = vA[i+2] | vB[i+2];
      ++f;
    }
    vC[i+3] = vA[i+3] & vB[i+3];
    if (vC[i+3] == 0) {
      vC[i+3] = vA[i+3] | vB[i+3];
      ++f;
    }
  }
  while (i < len) {
    vC[i] = vA[i] & vB[i];
    if (vC[i] == 0) {
      vC[i] = vA[i] | vB[i];
      ++f;
    }
    ++i;
  }
  return f;
}


